/*
    K8400 firmware modification based on original Version provided by Vellemann.

 Copyright (C) 2017 Holger Höhnemann

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

#include "Service.h"
#include "Services.h"
#include "printer.h"
#include <avr/pgmspace.h>

#define SERVICE(A,B) const char Str_##A[] PROGMEM =  B ;
#define SERVICEVAR(A) &Str_##A[0]


SERVICE (Service_Home,SERVICE_STR_AUTO_HOME)
SERVICE (Service_Dummy,SERVICE_DUMMY)
SERVICE (Service_Disable_Steppers,SERVICE_DISABLE_STEPPERS)
SERVICE (Service_Load_PLA_EX1,SERVICE_LOAD_PLA_EX1)
SERVICE (Service_Load_PLA_EX2,SERVICE_LOAD_PLA_EX2)
SERVICE (Service_Load_ABS_EX1,SERVICE_LOAD_ABS_EX1)
SERVICE (Service_Load_ABS_EX2,SERVICE_LOAD_ABS_EX2)
SERVICE (Service_Unload_PLA_EX1,SERVICE_UNLOAD_PLA_EX1)
SERVICE (Service_Unload_PLA_EX2,SERVICE_UNLOAD_PLA_EX2)
SERVICE (Service_Unload_ABS_EX1,SERVICE_UNLOAD_ABS_EX1)
SERVICE (Service_Unload_ABS_EX2,SERVICE_UNLOAD_ABS_EX2)
SERVICE (Service_Init_SDcard,SERVICE_INIT_SDCARD)
SERVICE (Service_Start_SD,SERVICE_START_SD)
SERVICE (Service_SD_Finished_Release,SERVICE_SD_FINISHED_RELEASECOMMAND)
SERVICE (Service_Extrude_For_Timer,SERVICE_EXTRUDE_FOR_TIMER)
SERVICE (Service_Set_T0,SERVICE_SET_T0)
SERVICE (Service_Set_T1,SERVICE_SET_T1)
SERVICE (Service_Filamentchange,SERVICE_FILAMENTCHANGE)


PGM_P service_list[]  = {
		SERVICEVAR(Service_Dummy),
		SERVICEVAR(Service_Home),
		SERVICEVAR(Service_Disable_Steppers),
		SERVICEVAR(Service_Load_PLA_EX1),
		SERVICEVAR(Service_Load_PLA_EX2),
		SERVICEVAR(Service_Load_ABS_EX1),
		SERVICEVAR(Service_Load_ABS_EX2),
		SERVICEVAR(Service_Unload_PLA_EX1),
		SERVICEVAR(Service_Unload_PLA_EX2),
		SERVICEVAR(Service_Unload_ABS_EX1),
		SERVICEVAR(Service_Unload_ABS_EX2),
		SERVICEVAR(Service_Init_SDcard),
		SERVICEVAR(Service_Start_SD),
		SERVICEVAR(Service_SD_Finished_Release),
		SERVICEVAR(Service_Extrude_For_Timer),
		SERVICEVAR(Service_Set_T0),
		SERVICEVAR(Service_Set_T1),
		SERVICEVAR(Service_Filamentchange)

};

Service::Service()
{
	// TODO Auto-generated constructor stub
	 printing = eof =false;
}

Service::~Service()
{
	// TODO Auto-generated destructor stub
}

bool Service::Printing()
{


	return printing;
}

char Service::Get()
{
	if (printing)
	{
		ch=pgm_read_byte(code++);

MSerial.print(ch);

		if (ch == EOF_CHAR || ch == '\0')
		{
			eof = true;
			printing = false;
			ch = '\n';
		}
		return ch;
	}
	else
		return '\n';
}

bool Service::Is_EOF()
{
	return eof;
}

void Service::Print(enum Services Service_nb)
{
	if (!printing)
	{

		my_printer.f_message(PSTR("service nr %i\n"),Service_nb);

		code = service_list[Service_nb];
		ch = '\0';
		printing = true;
		eof = false;

	}
}
